#include <iostream>
#include <opencv2\opencv.hpp>
#include <Windows.h>
#include <cmath>
#include <vector>
#include "EV3.hpp"
#define KEY_PUSH(key) (GetAsyncKeyState(key) & 0x0001)
#define KEY_DOWN(key) (GetAsyncKeyState(key) & 0x8000)
#define W 640
#define H 480
using namespace std;
using namespace cv;
Point queu[W*H];
Point queuK[W*H];
struct Options
{
	int x;
	int y;
	bool flag = 0;
};
void mouseCallback(int event, int a, int z, int flag, void* option)
{
	if (event == EVENT_LBUTTONDOWN)
	{
		cout << "Left Click" << '\n' << "x = " << a << "    " << '\n' << "y = " << z << endl;
		Options* opt = (Options*)option;
		(*opt).x = a;
		(*opt).y = z;
		(*opt).flag = 1;
	};
}
double getTime()
{
	return 1.0*clock() / CLOCKS_PER_SEC;
}
int main()
{
	namedWindow("Components");
	namedWindow("Trackbar");
	namedWindow("Good Pixels");
	EV3 ev3(EV3::MOTORS::MOTOR_B, EV3::MOTORS::MOTOR_C);
	ev3.connect(7);
	//
	Options mouseoption;
	mouseoption.x = 1;
	mouseoption.y = 1;
	setMouseCallback("Components", mouseCallback, (void*)&mouseoption);
	VideoCapture capture(1);
	int Hc = 177, Sa, Smin = 54, Smax = 255, Vmin = 90, Vmax = 255, Hv = 29, Ha, Va, Koaf = 7;
	int head = 0, tail = 0, ncomp = 0, queueP = 0, pixMax = 0, pixNow = 0, nObject, sumX = 0, sumY = 0, sumx = 0, sumy = 0;
	Vec3b rgb;
	createTrackbar("Hue", "Trackbar", &Hv, 255);
	createTrackbar("SaturMIN", "Trackbar", &Smin, 255);
	createTrackbar("SaturMAX", "Trackbar", &Smax, 255);
	createTrackbar("ValueMIN", "Trackbar", &Vmin, 255);
	createTrackbar("ValueMAX", "Trackbar", &Vmax, 255);
	createTrackbar("Koaficient", "Trackbar", &Koaf, 100);//don't forget to del on 10
	capture.set(CV_CAP_PROP_FRAME_WIDTH, W);
	capture.set(CV_CAP_PROP_FRAME_WIDTH, H);
	bool Pass = 0, Direct = 0;
	while (!KEY_PUSH(VK_ESCAPE))
	{
		Point queueP;
		Mat frame, hsv_frame, grey_frame, Inconstruct;
		capture >> frame;
		capture >> Inconstruct;
		Mat GoodPixels(Size(W, H), CV_8UC1);
		Mat compIndex(Size(W, H), CV_32SC1);
		Mat GoodPixelsK2(Size(W, H), CV_8UC1);
		compIndex = -1;
		GoodPixels = 0;
		cvtColor(frame, hsv_frame, CV_BGR2HSV);
		cvtColor(frame, grey_frame, CV_BGR2GRAY);
		if (mouseoption.flag == 1)
		{
			Hc = hsv_frame.at<Vec3b>(mouseoption.y, mouseoption.x)[0];
			mouseoption.flag = 0;
			rgb = frame.at<Vec3b>(mouseoption.y, mouseoption.x);
		}
		cout << Vec3b(Hc);
		for (int i = 0; i < W; i++)
		{
			for (int j = 0; j < H; j++)
			{
				Ha = hsv_frame.at<Vec3b>(j, i)[0];
				Sa = hsv_frame.at<Vec3b>(j, i)[1];
				Va = hsv_frame.at<Vec3b>(j, i)[2];
				if ((abs(Ha - Hc) < Hv) && ((Smin <= Sa) && (Sa <= Smax)) && ((Vmin <= Va) && (Va <= Vmax)))
				{
					//(Ha - Hc < Hv) -   
					GoodPixels.at<unsigned char>(j, i) = 255;
				}
			}
		}
		ncomp = 0;
		head = 0;
		tail = 0;
		pixMax = 0;
		for (int i = 0; i < W; i++)
		{
			for (int j = 0; j < H; j++)
			{
				pixNow = 0;
				if ((GoodPixels.at<unsigned char>(j, i) == 255) && (compIndex.at<int>(j, i) == -1))
				{
					compIndex.at<int>(j, i) = ncomp;
					queu[tail++] = Point(i, j);
					while (head != tail)
					{
						queueP = queu[head++];
						pixNow = pixNow + 1;
						sumx = sumx + queueP.x;
						sumy = sumy + queueP.y;
						for (int x = queueP.x - 1; x <= queueP.x + 1; x++)
						{
							for (int y = queueP.y - 1; y <= queueP.y + 1; y++)
							{
								if ((x >= 0) && (x + 1 <= W) && (y >= 0) && (y + 1 <= H) && (GoodPixels.at<unsigned char>(y, x) == 255) && (compIndex.at<int>(y, x) == -1))
								{
									compIndex.at<int>(y, x) = ncomp;
									queu[tail++] = Point(x, y);
								}
							}
						}
					}
					if (pixNow > pixMax)
					{
						pixMax = pixNow;
						nObject = ncomp;
						sumX = sumx;
						sumY = sumy;
					}
					sumx = 0;
					sumy = 0;
					ncomp++;
				}
			}
		}
		for (int i = 0; i < W; i++)
		{
			for (int j = 0; j < H; j++)
			{
				if (nObject == compIndex.at<int>(j, i)) //          ,       
				{
					frame.at<Vec3b>(j, i) = Vec3b(255, 255, 255); //      .  Ѩ!!! (   )
				}
			}
		}
		double  Xm, Ym, Xp, Yp, D = 78, h = 0.5, Skx = 0, Sky = 0;
		//
		if (pixMax)
		{
			circle(frame, Point(sumX / pixMax, sumY / pixMax), 20, Vec3b(rgb), 1);
			Xp = sumX / pixMax; //      
			Yp = sumY / pixMax;//      Y
			Xm = 2 * h*tan(2 * atan(tan(D / 2)*sin(atan(W / H))) / 2)*Xp / W;//   
			Ym = 2 * h*tan(2 * atan(tan(D / 2)*cos(atan(W / H))) / 2)*Yp / H;//   

		}
		Mat maska(frame.size(), CV_8UC1);
		maska = 0;
		rectangle(maska, Point(0, H/2), Point(W - 1, H - 1), Scalar(255), -1);
		vector <Point2f> corners;
		goodFeaturesToTrack(grey_frame, corners, 200, 0.1, 2, maska);
		for (int m = 0; m < corners.size(); m++)
		{
			circle(Inconstruct, Point(corners[m]), 15, Vec3b(255, 0, 0), -1);// 
		}
		int pixNowK = 0, pixMaxK, ncompK, headK, tailK, sumxK = 0, sumyK = 0, sumXK = 0, sumYK = 0, nObjectK;
		Point queuePK;
		Vec3b colorK = Vec3b(255, 0, 0);
		Mat GoodPixelsK(Size(W, H), CV_8UC1);
		Mat compIndexK(Size(W, H), CV_32SC1);
		GoodPixelsK = 0;
		compIndexK = -1;
		for (int xK = 0; xK < W; xK++)
		{
			for (int yK = 0; yK < H; yK++)
			{

				if (colorK == Inconstruct.at<Vec3b>(yK, xK))
				{
					GoodPixelsK.at<unsigned char>(yK, xK) = 255;
				}
			}
		}
		ncompK = 0;
		headK = 0;
		tailK = 0;
		pixMaxK = 0;
		for (int xK = 0; xK < W; xK++)
		{
			for (int yK = 0; yK < H; yK++)
			{
				pixNowK = 0;
				if ((GoodPixelsK.at<unsigned char>(yK, xK) == 255) && (compIndexK.at<int>(yK, xK) == -1))
				{
					compIndexK.at<int>(yK, xK) = ncompK;
					queuK[tailK++] = Point(xK, yK);
					while (headK != tailK)
					{
						queuePK = queuK[headK++];
						pixNowK = pixNowK + 1;
						sumxK = sumxK + queuePK.x;
						sumyK = sumyK + queuePK.y;
						for (int xPK = queuePK.x - 1; xPK <= queuePK.x + 1; xPK++)
						{
							for (int yPK = queuePK.y - 1; yPK <= queuePK.y + 1; yPK++)
							{
								if ((xPK >= 0) && (xPK + 1 <= W) && (yPK >= 0) && (yPK + 1 <= H) && (GoodPixelsK.at<unsigned char>(yPK, xPK) == 255) && (compIndexK.at<int>(yPK, xPK) == -1))
								{
									compIndexK.at<int>(yPK, xPK) = ncompK;
									queuK[tailK++] = Point(xPK, yPK);
								}
							}
						}
					}
					if (pixNowK > pixMaxK)
					{
						pixMaxK = pixNowK;
						nObjectK = ncompK;
						sumXK = sumxK;
						sumYK = sumyK;
					}
					sumxK = 0;
					sumyK = 0;
					ncompK++;
				}
			}
		}
		for (int xK = 0; xK < W; xK++)
		{
			for (int yK = 0; yK < H; yK++)
			{
				if (nObjectK == compIndexK.at<int>(yK, xK)) //          ,       
				{
					circle(Inconstruct, Point(xK, yK), 2, Vec3b(0, 0, 255), -1);
				}
			}
		}
		if (pixMaxK)
		{
			circle(frame, Point(sumXK / pixMaxK, sumYK / pixMaxK), 5, Vec3b(0, 255, 0), -1);
		}
		cvShowImage("Components", &(IplImage)frame);
		imshow("Good Pixels", nObjectK == compIndexK);
		//   
		//  - 1 ,  -2 ,  D - 
		if (pixMax == 0)
		{
			ev3.outputStop(EV3::MOTOR_A | EV3::MOTOR_B | EV3::MOTOR_C, EV3::STOP_FLOAT);
		}
		else
		{ 
		int  U, error, XB = sumX / pixMax, XR = sumXK / pixMaxK;
		int YB = sumY / pixMax, YR = sumYK / pixMaxK;
		error = XB - XR;
		//Koaf =  (Koaf );
		U = -1.0 *error * Koaf / 10;
		cout << U << endl;
		ev3.outputSpeed(EV3::MOTOR_C, U);
		ev3.outputSpeed(EV3::MOTOR_B, U);
		ev3.outputStart(EV3::MOTOR_C);
		ev3.outputStart(EV3::MOTOR_B);
		//time
		double t0;
		if (abs(YR - YB) <= 31 && Pass == 0)
		{
			t0 = getTime();
			Pass = 1;
			ev3.outputSpeed(EV3::MOTOR_D, -100);
			ev3.outputStart(EV3::MOTOR_D);
			Direct = 1;
		}
		if (Pass == 1)
		{
			if (getTime() - t0 > 0.5 && Direct == 1)
			{
				t0 = getTime();
				ev3.outputSpeed(EV3::MOTOR_D, 100);
				ev3.outputStart(EV3::MOTOR_D);
				Direct = 0;
			}
			if (getTime() - t0 > 0.5 && Direct == 0)
			{
				Pass = 0;
				ev3.outputSpeed(EV3::MOTOR_D, 10);
				ev3.outputStart(EV3::MOTOR_D);

			}
		}
//		if (YR < YB)
//		{
//			ev3.outputStop(EV3::MOTOR_A | EV3::MOTOR_B | EV3::MOTOR_C, EV3::STOP_FLOAT);
//		}
		}
		waitKey(1);
	}
	return 0;
}
